function [U_star] = adaptive_mpc(x, x0, ref, U_star, U_MPC, Ts, Np, Nc, Q, R, S, x_c, u_c, du_c, PointAndTangent, method, lpv)

U_old = U_star(:, end);
u_old = U_old(1:2);



%% Prediction
prediction_model = bicycle_pred_model(x0, ref, u_old, Ts, PointAndTangent, U_MPC, lpv);
% prediction_model = bicycle_pred_model_aug_states(x, ref, u_old, Ts, PointAndTangent, U_MPC, lpv);

prediction_model.x_c = x_c;
prediction_model.u_c = u_c;
prediction_model.du_c = du_c;


%% Optimization
if method == 0
    mpc = qp_matrices(prediction_model, Np, Nc, Q, R, S, x, x0, ref, U_old);
    options = optimset('Display', 'off');
    U_star = quadprog(mpc.H, mpc.f, mpc.A_ineq, mpc.b_ineq, [], [], [], [], [], options);
elseif method == 1
    U_star = yalmip_mpc(x, ref, u_old, Np, Q, R, S, prediction_model);
    U_star = reshape(U_star, 2*Np, 1);
end


end