function [pred_model] = bicycle_sl_position_model(Ts, p)

Lr = 0.75;
v = 1;

theta_0 = p(3);
delta_0 = p(4);


% Model
Ad = [1 0 0
      0 1 0
      0 0 1];
Bd = [-v*sin(theta_0+delta_0)*Ts
      v*cos(theta_0+delta_0)*Ts
      v/Lr*cos(delta_0)*Ts];

Kd = [v*cos(theta_0+delta_0)*Ts
      v*sin(theta_0+delta_0)*Ts
      v*cos(delta_0)*Ts];

Cd = [1 0 0
    0 1 0];
Dd = zeros(size(Cd,1), size(Bd,2));




%% Structure

pred_model.Ad = Ad;
pred_model.Bd = Bd;
pred_model.Kd = Kd;
pred_model.Cd = Cd;
pred_model.Dd = Dd;