function [pred_model] = point_kinematic_model(Ts)

%% State-space
A = [0 0 1 0; 0 0 0 1; 0 0 0 0; 0 0 0 0];
B = [0 0; 0 0; 1 0; 0 1];
C = eye(4);
D = zeros(size(C,1), size(B,2));


%% Matrices discretization
Ad = eye(size(A))+A*Ts;
Bd = B*Ts;
Cd = C;
Dd = D;


%% Structure
pred_model.A = Ad;
pred_model.B = Bd;
pred_model.C = Cd;
pred_model.D = Dd;

end