function [U_MPC] = adaptive_mpc_variation(X_MPC, x0, ref, U_MPC, U0, Ts, Np, Nc, Q, R, S, PointAndTangent, method, lpv)

u0 = U0(1:2);
u_MPC = U_MPC(1:2);


%% Constraints

% state constraints [vx, vy, wz, s, ey, epsi]
x_c = [-0.50,    +0.50
       -0.50,    +0.50
       -0.50,    +0.50
       0,        +0.50
       -0.50,    +0.50
       -0.50,    +0.50];

% input constraints [delta_f, a]
u_c = [-0.01,    +0.01
       -0.01,    +0.01];

% input rate constraints [delta_f, a]
du_c = [-inf,   +inf
        -inf,   +inf];




%% Prediction
prediction_model = bicycle_pred_model(x0, u0, Ts, PointAndTangent, U0, lpv);

if method == 0
    mpc = qp_matrices(prediction_model, Np, Nc, Q, R, S, x_c, u_c, du_c, X_MPC, ref, U_MPC);
    options = optimset('Display', 'off');
    U_MPC = quadprog(mpc.H, mpc.f, mpc.A_ineq, mpc.b_ineq, [], [], [], [], [], options);
elseif method == 1
    U_MPC = yalmip_mpc(X_MPC, ref, u_MPC, Np, Q, R, S, prediction_model, x_c, u_c, du_c);
    U_MPC = reshape(U_MPC, 2*Np, 1);
end


end